//+------------------------------------------------------------------+
//|                                                       FISHTSS_EA.mq4 |
//|                                            Copyright  2007, JAM |
//|                                                THE SIMPLE SYSTEM |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, JAM"
#property link "FISHTSS_EA by JAM"

//---- input parameters
extern double Lots         = 0.5;
extern double TakeProfit   = 90;
extern double StopLoss     = 35;
extern double TrailingStop = 60;
extern int    lefttop      = 11;
extern double first        = 33;
extern int    bot          =  4;
extern double second       = 12;
extern int    leftbot      = 11;
extern int    top          =  4;
extern double secondsel    = 12;
extern double firstsel     = 33;



double Points;
//+------------------------------------------------------------------+
//| expert initialization function |
//+------------------------------------------------------------------+
int init()
  {
   Points = MarketInfo(Symbol(), MODE_POINT);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//|        Expert Deinitialization                                   |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function |
//+------------------------------------------------------------------+

int start()
  {
   int cnt = 0, total, SymOrdTotal = 0;
   int i1, pp, shift;
   double Tv[2][500] ;
   double BuySig=0, SellSig=0, val3;

   if(AccountFreeMargin() < (100*Lots))
   {
      Print("ERROR:  Insufficient funds in Account!");
      return(0);
   }

   if(Bars < 100)
     {
       Print("ERROR: Number of Bars Less Than 100!");
       return(0); 
     }

   if(TakeProfit < 10)
     {
       Print("ERROR: TakeProfit Less Than 10!");
       return(0); 
     }
//=============================================================================
{  
   double ax1,ax0;

   {
   
   if(((Close[lefttop]-Close[bot])/Point)>=first &&
      ((Close[0]-Close[bot])/Point)>=second){BuySig=1;}  else {BuySig=0;}
      
   if(((Close[leftbot]-Close[top])/Point)>=firstsel &&
      ((Close[0]-Close[top])/Point)>=secondsel){SellSig=1;} else {SellSig=0;}
         
   
   
   
   }
}   
   
//==============================================================================
   total = OrdersTotal();

   for(cnt = 0; cnt < total; cnt++)
     {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if(OrderSymbol()==Symbol()){ SymOrdTotal++; }  
     }
   
   if ( SymOrdTotal==0 )
     {
       if( BuySig != 0 )
         {
           OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Ask-StopLoss*Point,
           Ask + TakeProfit*Points,"BARS ONLY", 15555, 0, Aqua); 
           if(GetLastError() == 0)
               Print("Buy Order Opened @ ", OrderOpenPrice());
           return(0); 
         }

       if( SellSig != 0 )
         {
           OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Bid+StopLoss*Point,
           Bid - TakeProfit*Points,"BARS ONLY", 15555, 0, Red); 
           if(GetLastError() == 0)
               Print("Sell Order Opened: ", OrderOpenPrice());
           return(0); 
         }
    }

   total = OrdersTotal();

   for(cnt = 0; cnt < total; cnt++)
     {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if(OrderType() <= OP_SELL && 
          OrderSymbol()==Symbol())  
         {
           if(OrderType() == OP_BUY) 
             {
               if(SellSig != 0)
                 {
                   OrderClose(OrderTicket(), OrderLots(), Bid, 3, Violet); 
                   return(0); 
                 }
               if(TrailingStop > 0) 
                 { 
                   if(Bid - OrderOpenPrice() > Points*TrailingStop)
                     {
                       if(OrderStopLoss() < Bid - Points*TrailingStop)
                         {
                           OrderModify(OrderTicket(), OrderOpenPrice(), 
                                       Bid - Points*TrailingStop, 
                                       OrderTakeProfit(), 0, Red);
                           return(0);
                         }
                     }
                 }
             }
           else 
             {
               if(BuySig != 0)
                 {
                   OrderClose(OrderTicket(), OrderLots(), Ask, 3, Violet); 
                   return(0); 
                 }
               if(TrailingStop > 0) 
                 { 
                   if((OrderOpenPrice() - Ask) > (Points*TrailingStop))
                     {
                       if(OrderStopLoss() == 0.0 || OrderStopLoss() > 
                          (Ask + Points*TrailingStop))
                         {
                           OrderModify(OrderTicket(), OrderOpenPrice(), 
                                       Ask + Points*TrailingStop, 
                                       OrderTakeProfit(), 0, Red);
                           return(0);
                         }
                     }
                 }
             }
         }
     }
   return(0);
  }
//+------------------------------------------------------------------+

